using System;
using System.IO;
using System.Collections;

namespace Aatlantis
{
	struct Rect {
		public double x1, x2, y1, y2;
		public Rect(double x1, double x2, double y1, double y2) {
			this.x1 = x1;
			this.x2 = x2;
			this.y1 = y1;
			this.y2 = y2;
		}

		public ArrayList Divide(Rect rect) {
			ArrayList ret = new ArrayList();
			Rect org = this; //this is structure
			while (true) {
				if (rect.x1 <= org.x1 && rect.x2 >= org.x2 && rect.y1 <= org.y1 && rect.y2 >= org.y2) {
					break;
				} else if (rect.x1 > org.x1 && rect.x1 < org.x2) {
					ret.Add(new Rect(org.x1, rect.x1, org.y1, org.y2));
					org = new Rect(rect.x1, org.x2, org.y1, org.y2);
				} else if (rect.x2 > org.x1 && rect.x2 < org.x2) {
					ret.Add(new Rect(rect.x2, org.x2, org.y1, org.y2));
					org = new Rect(org.x1, rect.x2, org.y1, org.y2);
				} else if (rect.y1 > org.y1 && rect.y1 < org.y2) {
					ret.Add(new Rect(org.x1, org.x2, org.y1, rect.y1));
					org = new Rect(org.x1, org.x2, rect.y1, org.y2);
				} else if (rect.y2 > org.y1 && rect.y2 < org.y2) {
					ret.Add(new Rect(org.x1, org.x2, rect.y2, org.y2));
					org = new Rect(org.x1, org.x2, org.y1, rect.y2);
				} else {
					ret.Add(org);
					break;
				}
			}
			return ret;
		}
		public double Area() {
			return (x2 - x1) * (y2 - y1);
		}
		public override String ToString() {
			return x1 + " " + x2 + " " + y1 + " " + y2 + " ";
		}
	}
	class Region {
		static ArrayList rects = new ArrayList();
		public static void Add(Rect rect) {
			ArrayList tmpRects = new ArrayList();
			tmpRects.Add(rect);

			IEnumerator e1 = rects.GetEnumerator();
			while (e1.MoveNext()) {
				ArrayList tmpRects2 = new ArrayList();
				IEnumerator e2 = tmpRects.GetEnumerator();
				while (e2.MoveNext()) {
					tmpRects2.AddRange(((Rect)e2.Current).Divide((Rect)e1.Current));
				}
				tmpRects = tmpRects2;
			}
			rects.AddRange(tmpRects);
			System.Console.Error.WriteLine("Size = " + rects.Count);
		}
		public static void Clear() {
			rects = new ArrayList();
		}

		public static double Result() {
			double ret = 0.0;
			IEnumerator e = rects.GetEnumerator();
			while (e.MoveNext()) {
				System.Console.Error.WriteLine(e.Current);
				ret += ((Rect)e.Current).Area();
			}
			return ret;
		}
	}

	class Class1
	{

		[STAThread]
		static void Main(string[] args)
		{
			StreamReader reader = new StreamReader("atlantis.in");
			int i;
			int n_input = 0;
			while (true) {
				n_input++;
				String line = reader.ReadLine();
				int n = int.Parse(line);
				System.Console.Error.WriteLine("n = " + n);
				if (n == 0)
					break;

				Region.Clear();
				for (i = 0; i < n; i++) {
					System.Console.Error.Write("i = " + i);
					line = reader.ReadLine();
					String[] datas = line.Split(null);
					Region.Add(new Rect(double.Parse(datas[0]),
										double.Parse(datas[2]),
										double.Parse(datas[1]),
										double.Parse(datas[3])));
				}
				System.Console.WriteLine("Test case #" + n_input);
				System.Console.WriteLine("Total explored area: " + Region.Result().ToString("F2"));
				System.Console.WriteLine("");
			}
		}
	}
}
